﻿//<debug />
//<assembly>API/ISD.CAD.IO.dll</assembly>

using System;
//using System.Windows.Forms;
using System.Windows;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Controls;
//using PresentationCore;
using System.Xaml;
//using PresentationFramework;

using ISD.Scripting;
using ISD.BaseTypes;
using ISD.Math;
using ISD.CAD.Base;
using ISD.CAD.Data;
using ISD.CAD.Contexts;
using ISD.CAD.Creators;
using ISD.CAD.Modifiers;
using ISD.CAD.Views;




class Script : ISD.Scripting.ScriptBase
{
    [ISD.Scripting.Context(typeof(UnconstrainedContext))]


    public static void Main()
    {

        // new Drawing with Assemblys
        string drawingPadandName = Context.Configuration.GetProductPath("C") + "Neue Szene";
        Scene drawing = Context.NewSceneSlot(drawingPadandName);

        // Create main Assembly
        var ac = new AssemblyCreator();
        AssemblyNode main = Context.CreateMainAssembly(ac);
        main.Name = "Struktur";


        // Box defintion




        //Make Window
        Window win = new Window();
        win.Title = "Auswahl";
        win.Height = 320;
        win.Width = 230;

        //Grid
        Grid myGrid = new Grid();
        myGrid.HorizontalAlignment = HorizontalAlignment.Left;
        myGrid.VerticalAlignment = VerticalAlignment.Center;


        // Ad columns
        myGrid.ColumnDefinitions.Add(new ColumnDefinition());
        myGrid.ColumnDefinitions.Add(new ColumnDefinition());

        // Define rows
        myGrid.RowDefinitions.Add(new RowDefinition());
        myGrid.RowDefinitions.Add(new RowDefinition());
        myGrid.RowDefinitions.Add(new RowDefinition());
        myGrid.RowDefinitions.Add(new RowDefinition());
        myGrid.RowDefinitions.Add(new RowDefinition());
        myGrid.RowDefinitions.Add(new RowDefinition());
        myGrid.RowDefinitions.Add(new RowDefinition());
        myGrid.RowDefinitions.Add(new RowDefinition());
        myGrid.RowDefinitions.Add(new RowDefinition());
        myGrid.RowDefinitions.Add(new RowDefinition());
        myGrid.RowDefinitions.Add(new RowDefinition());
        myGrid.RowDefinitions.Add(new RowDefinition());
        myGrid.RowDefinitions.Add(new RowDefinition());

        // Add the first text cell to the Grid
        TextBlock txt1 = new TextBlock();
        txt1.Text = "    Hilfsteile   ";
        txt1.FontSize = 14;
        txt1.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt1, 0);
        Grid.SetColumn(txt1, 0);

        //usw
        TextBlock txt2 = new TextBlock();
        txt2.Text = "    Tragwerk    ";
        txt2.FontSize = 14;
        txt2.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt2, 1);
        Grid.SetColumn(txt2, 0);

        TextBlock txt3 = new TextBlock();
        txt3.Text = "    Binder   ";
        txt3.FontSize = 14;
        txt3.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt3, 2);
        Grid.SetColumn(txt3, 0);

        TextBlock txt4 = new TextBlock();
        txt4.Text = "  Druck-Koppel  ";
        txt4.FontSize = 14;
        txt4.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt4, 3);
        Grid.SetColumn(txt4, 0);

        TextBlock txt5 = new TextBlock();
        txt5.Text = "  Wandriegel   ";
        txt5.FontSize = 14;
        txt5.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt5, 4);
        Grid.SetColumn(txt5, 0);

        TextBlock txt6 = new TextBlock();
        txt6.Text = "  Pfetten   ";
        txt6.FontSize = 14;
        txt6.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt6, 5);
        Grid.SetColumn(txt6, 0);

        TextBlock txt7 = new TextBlock();
        txt7.Text = "  Treppen   ";
        txt7.FontSize = 14;
        txt7.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt7, 6);
        Grid.SetColumn(txt7, 0);

        TextBlock txt8 = new TextBlock();
        txt8.Text = "  Geländer   ";
        txt8.FontSize = 14;
        txt8.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt8, 7);
        Grid.SetColumn(txt8, 0);

        TextBlock txt9 = new TextBlock();
        txt9.Text = "  Beläge   ";
        txt9.FontSize = 14;
        txt9.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt9, 8);
        Grid.SetColumn(txt9, 0);

        TextBlock txt10 = new TextBlock();
        txt10.Text = "   ";
        txt10.FontSize = 14;
        txt10.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt10, 9);
        Grid.SetColumn(txt10, 0);

        TextBlock txt11 = new TextBlock();
        txt11.Text = "  Alle  ";
        txt11.FontSize = 14;
        txt11.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt11, 10);
        Grid.SetColumn(txt11, 0);

        //checkboxes
        var checkbox1 = new CheckBox();
        Grid.SetRow(checkbox1, 0);
        Grid.SetColumn(checkbox1, 1);
        myGrid.Children.Add(checkbox1);

        var checkbox2 = new CheckBox();
        Grid.SetRow(checkbox2, 1);
        Grid.SetColumn(checkbox2, 1);
        myGrid.Children.Add(checkbox2);

        var checkbox3 = new CheckBox();
        Grid.SetRow(checkbox3, 2);
        Grid.SetColumn(checkbox3, 1);
        myGrid.Children.Add(checkbox3);

        var checkbox4 = new CheckBox();
        Grid.SetRow(checkbox4, 3);
        Grid.SetColumn(checkbox4, 1);
        myGrid.Children.Add(checkbox4);

        var checkbox5 = new CheckBox();
        Grid.SetRow(checkbox5, 4);
        Grid.SetColumn(checkbox5, 1);
        myGrid.Children.Add(checkbox5);

        var checkbox6 = new CheckBox();
        Grid.SetRow(checkbox6, 5);
        Grid.SetColumn(checkbox6, 1);
        myGrid.Children.Add(checkbox6);

        var checkbox7 = new CheckBox();
        Grid.SetRow(checkbox7, 6);
        Grid.SetColumn(checkbox7, 1);
        myGrid.Children.Add(checkbox7);

        var checkbox8 = new CheckBox();
        Grid.SetRow(checkbox8, 7);
        Grid.SetColumn(checkbox8, 1);
        myGrid.Children.Add(checkbox8);

        var checkbox9 = new CheckBox();
        Grid.SetRow(checkbox9, 8);
        Grid.SetColumn(checkbox9, 1);
        myGrid.Children.Add(checkbox9);

        var checkbox10 = new CheckBox();
        Grid.SetRow(checkbox10, 10);
        Grid.SetColumn(checkbox10, 1);
        myGrid.Children.Add(checkbox10);

        //Button
        Button btn = new Button();
        btn.Content = "Weiter";
        btn.Width = 100;
        btn.Height = 25;
        btn.Click += delegate (object sender, RoutedEventArgs e)
        {
            win.Close();
        };

        Grid.SetRow(btn, 11);
        Grid.SetColumn(btn, 1);
        myGrid.Children.Add(btn);


        // Add the TextBlock elements to the Grid Children collection
        myGrid.Children.Add(txt1);
        myGrid.Children.Add(txt2);
        myGrid.Children.Add(txt3);
        myGrid.Children.Add(txt4);
        myGrid.Children.Add(txt5);
        myGrid.Children.Add(txt6);
        myGrid.Children.Add(txt7);
        myGrid.Children.Add(txt8);
        myGrid.Children.Add(txt9);
        myGrid.Children.Add(txt10);
        myGrid.Children.Add(txt11);

        // Add the Grid as the Content of the Parent Window Object
        win.Content = myGrid;
        win.ShowDialog();


        // Auswahl auswerten und die gewünschte Baugruppen erstellen
        if (Convert.ToBoolean(!checkbox10.IsChecked))
        {
            if (Convert.ToBoolean(checkbox1.IsChecked))
            {
                Part subHilfsteile = CreateSubAssembly_3("Hilfsteile");
            }

            if (Convert.ToBoolean(checkbox2.IsChecked))
            {
                Part subTragwerk = CreateSubAssembly_2("Tragwerk");
            }
            if (Convert.ToBoolean(checkbox3.IsChecked))
            {
                Part subBinder = CreateSubAssembly_1("Binder");
            }

            if (Convert.ToBoolean(checkbox4.IsChecked))
            {
                Part subDruck = CreateSubAssembly_1("Druck- und Koppelstäbe, Verbande");
            }
            if (Convert.ToBoolean(checkbox5.IsChecked))
            {
                Part subWand = CreateSubAssembly_1("Wandriegel");
            }

            if (Convert.ToBoolean(checkbox6.IsChecked))
            {
                Part subPfetten = CreateSubAssembly_1("Pfetten");
            }

            if (Convert.ToBoolean(checkbox7.IsChecked))
            {
                Part subTreppen = CreateSubAssembly_1("Treppen");
            }

            if (Convert.ToBoolean(checkbox8.IsChecked))
            {
                Part subGeländer = CreateSubAssembly_1("Geländer");
            }

            if (Convert.ToBoolean(checkbox9.IsChecked))
            {
                Part subBeläge = CreateSubAssembly_1("Beläge");
            }

        }
        else

        {
            Part subHilfsteile = CreateSubAssembly_3("Hilfsteile");
            Part subTragwerk = CreateSubAssembly_2("Tragwerk");
            Part subBinder = CreateSubAssembly_1("Binder");
            Part subDruck = CreateSubAssembly_1("Druck- und Koppelstäbe, Verbande");
            Part subWand = CreateSubAssembly_1("Wandriegel");
            Part subPfetten = CreateSubAssembly_1("Pfetten");
            Part subTreppen = CreateSubAssembly_1("Treppen");
            Part subGeländer = CreateSubAssembly_1("Geländer");
            Part subBeläge = CreateSubAssembly_1("Beläge");
        }




    }

    //first type of assemblys
    private static Part CreateSubAssembly_1(string subname)

    {
        try
        {
            AssemblyCreator sub = new AssemblyCreator();
            sub.Name = subname;
            AssemblyNode subgroup = Context.CreateAssembly(sub, Context.ActiveScene.MainAssembly);

            // create Sub assembly 'Baugruppe'in above assembly
            AssemblyCreator sub_2 = new AssemblyCreator();
            sub_2.Name = "Baugrupe";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup2 = Context.CreateAssembly(sub_2, subgroup);

            // create Sub assembly 'Baugruppe'in above assembly
            AssemblyCreator sub_3 = new AssemblyCreator();
            sub_3.Name = "Losteile";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup3 = Context.CreateAssembly(sub_3, subgroup);

            // create Sub assembly 'Baugruppe'in above assembly
            AssemblyCreator sub_4 = new AssemblyCreator();
            sub_4.Name = "Norm und Kaufteile";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup4 = Context.CreateAssembly(sub_4, subgroup);


            return null;

        }

        catch (System.Exception e)
        {
            MessageBox.Show("Assembly creation has failed, try agian please");
            return null;
        }
    }

    //second type of assemblys
    private static Part CreateSubAssembly_2(string subname)

    {
        try
        {
            AssemblyCreator sub = new AssemblyCreator();
            sub.Name = subname;
            AssemblyNode subgroup = Context.CreateAssembly(sub, Context.ActiveScene.MainAssembly);

            AssemblyCreator sub_2 = new AssemblyCreator();
            sub_2.Name = "Baugrupe";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup2 = Context.CreateAssembly(sub_2, subgroup);

            AssemblyCreator sub_3 = new AssemblyCreator();
            sub_3.Name = "Losteile";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup3 = Context.CreateAssembly(sub_3, subgroup);

            AssemblyCreator sub_4 = new AssemblyCreator();
            sub_4.Name = "Norm und Kaufteile";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup4 = Context.CreateAssembly(sub_4, subgroup);

            AssemblyCreator sub_5 = new AssemblyCreator();
            sub_5.Name = "Stützen";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup5 = Context.CreateAssembly(sub_5, subgroup);



            return null;

        }

        catch (System.Exception e)
        {
            MessageBox.Show("Assembly creation has failed, try agian please");
            return null;
        }
    }
    //Third type of assemblys
    private static Part CreateSubAssembly_3(string subname)

    {
        try
        {
            AssemblyCreator sub = new AssemblyCreator();
            sub.Name = subname;
            AssemblyNode subgroup = Context.CreateAssembly(sub, Context.ActiveScene.MainAssembly);

            AssemblyCreator sub_2 = new AssemblyCreator();
            sub_2.Name = "Raster";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup2 = Context.CreateAssembly(sub_2, subgroup);

            AssemblyCreator sub_3 = new AssemblyCreator();
            sub_3.Name = "SKizzen";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup3 = Context.CreateAssembly(sub_3, subgroup);

            AssemblyCreator sub_4 = new AssemblyCreator();
            sub_4.Name = "Bestand";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup4 = Context.CreateAssembly(sub_4, subgroup);

            AssemblyCreator sub_5 = new AssemblyCreator();
            sub_5.Name = "Sonstiges";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup5 = Context.CreateAssembly(sub_5, subgroup);



            return null;

        }

        catch (System.Exception e)
        {
            MessageBox.Show("Assembly creation has failed, try agian please");
            return null;
        }
    }


    //end of the show!!

    public static UnconstrainedContext Context
    {
        get { return BaseContext as UnconstrainedContext; }
    }



}
